#!/usr/local/bin/ruby 

#######################################
# cgi_prescrib2png
#
# A CGI script for converting a Prescribble.dat into a PNG.
# Still a hack.
#
# Author: Kent Dahl ( MenThal@bigfoot.com )
#
# Requirements: 
# - Ruby ( http://www.lang-ruby.org )
# - NQXML ( http://www.io.com/~jimm/downloads/nqxml/index.html )
# - GD graphics library with PNG support
# - Ruby/GD library binding
#
#


require 'cgi'
require 'prescrib2png'
require 'tempfile'



cgi = CGI.new

f = cgi["pics"]

begin
  

  if f.nil? #! f.kind_of?(Tempfile) 
     raise "Not given file!"
  else
    f = f[0]
  end


  books = Prescribble::loadPrescribbleStrokes( f.local_path )

  if books.nil? && books.size != 1 then raise "Unexpected notebook size!" end

  im = Prescribble::makeGDImage( books[0] ) 

  print "Content-type: image/png\r\n\r\n" 
  im.png STDOUT
  STDOUT.flush

rescue Exception => err
  print "Content-type: text/html\r\n\r\n"
  print "<HTML><BODY>"
  print "<H1>ERROR!</H1>\n" + err.to_s 
  print "\n\n"
  print "</BODY></HTML>"
end
